#
# spec file for package lite-xl-plugins
#
# Copyright (c) 2022 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#

%define programname lite-xl
Name:           lite-xl-plugins
Version:        git20221231.bf3a3b7
Release:        bp155.1.4
Summary:        Additional plugins for %{programname}
License:        MIT
URL:            https://github.com/lite-xl/lite-xl-plugins
Source0:        %{name}-%{version}.tar.gz
### https://raw.githubusercontent.com/lite-xl/console/master/init.lua ==> console.lua
Source1:        console.lua
### https://github.com/yamatsum/nonicons/raw/master/dist/nonicons.ttf
Source2:        nonicons.ttf
### https://raw.githubusercontent.com/vincens2005/lite-xl-gitdiff-highlight/master/init.lua
Source3:        gitdiff_highlight-init.lua
### https://raw.githubusercontent.com/vincens2005/lite-xl-gitdiff-highlight/master/gitdiff.lua
Source4:        gitdiff_highlight-gitdiff.lua
Source5:        smb-addl-nonicons.txt
Patch0:         nonicons-userdir.diff
Recommends:     words
Requires:       lite-xl
Requires:       lite-xl-widgets
BuildArch:      noarch

%description
Plugins for the Lite XL text editor, originally forked from the lite plugins repository.

%prep
%setup -q
%patch0

%build
sed -i '/  -- Following without special icon:/ r %{SOURCE5}' %{_builddir}/%{name}-%{version}/plugins/nonicons.lua

%install
mkdir -p %{buildroot}%{_datadir}/%{programname}/plugins
mkdir -p %{buildroot}%{_datadir}/%{programname}/plugins/editorconfig/tests/{glob,parser,properties}
mkdir -p %{buildroot}%{_datadir}/%{programname}/plugins/profiler
mkdir -p %{buildroot}%{_datadir}/%{programname}/plugins/gitdiff_highlight
mkdir -p %{buildroot}%{_datadir}/%{programname}/fonts
mkdir -p %{buildroot}%{_datadir}/doc/%{name}
### 'console.lua' seems to exist independent of what git repo provides/
cp -v %{SOURCE1} plugins/
#####
### 20221005, throwing error
#rm -v plugins/ipc.lua
# in ~/.config/lite-xl/init.lua:
# config.plugins.ipc = false
#####
install -D -m644 plugins/*.lua %{buildroot}%{_datadir}/%{programname}/plugins
install -D -m644 plugins/editorconfig/{*.md,*.lua} %{buildroot}%{_datadir}/%{programname}/plugins/editorconfig
install -D -m644 plugins/editorconfig/tests/*.lua %{buildroot}%{_datadir}/%{programname}/plugins/editorconfig/tests
install -D -m644 plugins/editorconfig/tests/glob/{*.in,*.lua} %{buildroot}%{_datadir}/%{programname}/plugins/editorconfig/tests/glob
install -D -m644 plugins/editorconfig/tests/parser/{*.in,*.lua} %{buildroot}%{_datadir}/%{programname}/plugins/editorconfig/tests/parser
install -D -m644 plugins/editorconfig/tests/properties/{*.in,*.lua} %{buildroot}%{_datadir}/%{programname}/plugins/editorconfig/tests/properties
install -D -m644 plugins/profiler/* %{buildroot}%{_datadir}/%{programname}/plugins/profiler
install -D -m644 %{SOURCE2} %{buildroot}%{_datadir}/%{programname}/fonts
install -D -m644 %{SOURCE3} %{buildroot}%{_datadir}/%{programname}/plugins/gitdiff_highlight/init.lua
install -D -m644 %{SOURCE4} %{buildroot}%{_datadir}/%{programname}/plugins/gitdiff_highlight/gitdiff.lua
install -D -m644 LICENSE %{buildroot}%{_datadir}/doc/%{name}/LICENSE
install -D -m644 README.md %{buildroot}%{_datadir}/doc/%{name}/README.md

%files
%dir %{_datadir}/%{programname}
%dir %{_datadir}/%{programname}/plugins
%dir %{_datadir}/%{programname}/plugins/gitdiff_highlight
%dir %{_datadir}/%{programname}/fonts
%dir %{_datadir}/doc/%{name}
%{_datadir}/%{programname}/plugins/*
%{_datadir}/%{programname}/fonts/*
%{_datadir}/doc/%{name}/LICENSE
%{_datadir}/doc/%{name}/README.md

%changelog
* Sat Dec 31 2022 scott.bradnick@suse.com
- Update to version git20221231.bf3a3b7:
  * readme: add evergreen to plugin list (#184)
  * `minimap`: Fix crash if `avoid_small_docs` and `linewrapping` are both enabled
  * Add highlighting for go.mod and go.sum files (#182)
  * Extend eval plugin with eval:selected (#177)
  * Add `tab_switcher` (#173)
  * Fix lfautoinsert (#180)
  * Improved language_wren.lua (#171)
  * added editorconfig plugin (#163)
  * regexreplacepreview: compat fixes for lite-xl master
  * Fix bug with rainbowparen.lua messing with the ability to comment out lines. (#170)
  * language_php: switch to non capturing group match
  * centerdoc: better spacing on center mode
  * Reorganize README.md
  * custom_caret: better handle of default caret color
  * ipc: annotation changes
  * settings: merge a plugin settings when enabled at runtime
  * feat: add group method for fontconfig plugin (#157)
  * [Plugin] Add Custom Caret Plugin (#162)
  * Update README.md
  * settings: ask before clearing font cache
  * profiler: rephrased parts of the readme
  * readme: chopped long lines, added directory to install
  * Add Profiler Plugin (#155)
  * Reorganize README.md (#156)
  * add gitblame plugin (#154)
  * settings: support global force scrollbar status on newly opened Views
  * settings: apply force_scrollbar_status on the fly
  * settings: added force_scrollbar_status
  * language_php: better match class type inline vars
  * language_rust: better lifetime syntax support (#152)
  * Update language_rivet.lua
  * language_php: added backticks support
  * language_php: fix highlighting outside of markdown code tags
  * language_php: add missing yield keyword
  * add nelua support to lfautoinsert (#150)
  * Added extra file extensions to language_sh.lua (#145)
  * language_php: applied changes from #108
  * settings: added new option keep_newline_whitespace
  * Removed extra item in list (#142)
  * macmodkeys: added missing params
  * Add workaround for sorted `Doc:get_selection` issue (#141)
  * Reorganize README.md (#139)
  * Use new `command.add` syntax (#136)
* Fri Nov  4 2022 Scott Bradnick <scott.bradnick@suse.com>
- Adjusting gitdiff_highlight-{gitdiff,init}.lua to play nice with
  lite-xl v2.1 plugin scheme (produces red notification bar and
  disables plugin when lite-xl loads otherwise)
* Thu Nov  3 2022 scott.bradnick@suse.com
- Update to version git20221101.0971a7a:
  * Changed minimap to accomodate new API.
  * language_php: fix strings not getting terminated
  * minimap: check docview has minimap scroll
  * minimap: fixed small mistake
  * Minimap Rework with Scrollbar (#134)
  * language_meson: added meson_options.txt and fixed meson.build patter
  * indentguide: do not apply on CommandView and allow toggling it.
  * Map ruby syntax to Gemfile and Gemfile.lock (#132)
  * Add `language_erb` to README
  * Add language plugin for ERB files (#130)
  * Removed language_cpp, as it's in the core, and not in this repo at all, in this branch.
* Thu Oct 13 2022 Scott Bradnick <scott.bradnick@suse.com>
- Removing unused nonicons.patch
- Renaming nonicons-userdir.patch to nonicons-userdir.diff
* Wed Oct  5 2022 scott.bradnick@suse.com
- Update to version git20221005.b1bc52f:
  * ipc: add different methods of opening directories
* Wed Oct  5 2022 scott.bradnick@suse.com
- Update to version git20221004.2eb56c5:
  * Added support for LaTex package and class syntax highlighting
  * Update list of Fennel keywords to everything covered by 1.2.0 (#126)
  * add inter-process communication (ipc) plugin (#127)
  * regexreplacepreview: drop deprecated call to commandview set text
  * spellcheck: updated config spec to support file type
  * Update `language_rivet.lua` (#125)
  * nonicons: support dynamic scaling
  * settings: added support for file and directory options
  * Add syntax highlighting to JSX tags (#118)
  * Syntax highlighter for the MiniScript programming language (#124)
  * `language_assembly_x86`: Add name
  * settings: reapply user project and init settings after load, also added clear font cache button
  * Added an option for number of parens
  * Add `primary_selection`
* Wed Aug 31 2022 Scott Bradnick <scott.bradnick@suse.com>
- Some prep for lite-xl version 2.1.0:
  * switched to upstream 2.1 branch
  * pulled in and added new 'console.lua' (console-new.lua)
  * updated patch for new 'nonicons.lua' (nonicons-userdir.patch)
  * removed the following 2 files as they were fixed upstream:
  * indentguide.lua
  * datetimestamps.patch
* Wed Aug 31 2022 scott.bradnick@suse.com
- Update to version git20220822.6700c4f:
  * removed linecopypaste as it is now part of core
  * settings: revert to default fonts on load error
  * settings: handle font loading error
  * Update nonicons.lua 2.1
  * fixed some minor mistakes
  * Use new `StatusView:add_item` syntax (#117)
  * `autoinsert`: remove initial refactoring code added by mistake
  * `autoinsert`: avoid deleting wrong characters
  * Update language_rivet.lua
  * `language_crystal`: remove file as we're linking to an external repo
  * Fixed Crystal Plugin Link (#113) * Fixed Crystal Plugin Link
  * Added language_ignore plugin (#111)
  * Corrected wrong term: ss -> gif
  * settings: error if widgets not found with url to repo
  * settings: fixed default font handling
  * settings: set about title font as reference of big_font
  * settings: dont make toolbarview a requirement
  * Added missing * to console plugin in README
  * Syntax highlighting for intel x86 assembly (#107)
  * settings: added ability to configure text and code fonts
  * settings: fix theme loading on MacOSX when fd's have been exceeded
  * Added language_env plugin
  * updates to new command_view:enter interface
  * force_syntax: use new command_view:enter interface
  * language_cpp: removed
  * linenumbers: fix gutter width and centerdoc combo
  * centerdoc: fix gutter width issues
  * `minimap`: align rects to pixel grid
  * settings: better about childs update strategy
  * Add language_caddyfile (#104)
  * `nonicons`: link to invariable font download
  * Fix incorrect link to Crystal syntax highlighting (#94)
  * Add support for SQL strings to language_php
  * Fixed wrong icon on opened directory
  * Add language_htaccess
  * `minimap`: handle more cache invalidation cases
  * `minimap`: don't crash with colors with invalid alpha
  * `minimap`: fix cutoff offset
  * language_v: add syntax support for raw strings
  * language_go: add syntax support for Go generic functions
  * language_v: add missing table to files
  * `minimap`: correctly manage inserted/removed lines
  * `minimap`: performance improvements (cache, merge, avoid splitting)
  * `minimap`: allow per-`DocView` toggle even if globally disabled
  * settings: added tooltip to website button
  * settings: added about pane and status bar options
  * changed indentation to 2 spaces for consistency across the repo
  * align_caret: correct mod version
  * `minimap`: Add per-`DocView` toggle and option to hide on small docs (#96)
  * language_php: support heredocs and variables inside strings
  * Add `align_carets` (#89)
  * language_go: small fixes (#95)
  * added wordcount plugin
  * language_go: extended matching and other improvements
  * bracketmatch: return line height on DocView:draw_line_text
  * Add more `bracketmatch` styles (#81)
  * settings: optimizations and properly apply plugins skip versions
  * settings: remove no longer applicable show spaces option
  * fix wrong loading order of user enabled plugins
  * removed lite-xl version and left only mod version
  * settings: save settings on theme change
  * settings: clean previous binds on apply_kybinding()
  * colorpreview: enable by default
  * autosave: enable by default
  * renamed enable to enabled to match all plugins
  * colorpreview: allow live disabling
  * autosave: allow live disabling
  * settings: do not save at exit to prevent config conflicts with other lite-xl instances
  * added config_spec and other plugin compatibility fixes.
  * settings: load config_spec of plugins enabled after startup
  * settings: allow empty descriptions with default value
  * settings: call scan_plugins_spec() before merge_settings()
  * settings: added ability to scan for plugins config_spec.
  * Add settings gui plugin (#65)
  * indentguide: renamed idx to line
  * colorpreview: renamed idx to line
  * smoothcaret: fixed new line wrap issue
  * Fix various plugins for linewrapping
  * minimap: simplify predicate since Object:is is now strict
  * lfautoinsert: make use of new strict predicate
  * Added asterisk
  * Added exterm
  * Updated spellcheck to work with linewrapping.
  * minimap: fix to work with lite-xl#916
  * language_yaml: also support bracket lists after hyphens
  * language_yaml: fixes and improvements
  * add treeview-menu-extender plugin (#36)
  * autowrap: removed no longer needed command see lite-xl #889
  * nonicons.lua: Use features from v2.1
  * language_glaz: update mod and lite-xl version.
  * hidelinenumbers: removed, the linenumbers plugin provides a better alternative
  * hidestatus: remove since the statusbar provides this now
  * force_syntax: use new StatusView api
  * rainbowparen: added ability to toggle.
  * autowrap: show status on toggle
  * spellcheck: added toggle command
  * autowrap: fixed missing require 'core.common', added toggle command
  * bigclock: fixed fonts loading and improved performance by copying only on scale changes
  * centerdoc: added toggle and zen mode toggle commands
  * datetimestamps: added insert custom command
  * eval: fixed eval:replace command
  * gitstatus: use new StatusView api
  * linenumbers: changed to new standard config method
  * memoryusage: use new StatusView api, use two decimals
  * opacity: added some notifications
  * openselected: added context menu, changed conflicting shortcut
  * restoretabs: set command predicate to nil
  * scalestatus: use new StatusView api
  * smallclock: use new StatusView api, removed coroutine
  * spellcheck: added context menu
  * statusclock: use new StatusView api, removed coroutine optional core.redraw when %%S is user
  * tabnumbers: make use of an unused variable
  * unboundedscroll: added command to toggle
  * regexreplacepreview: use table.unpack in place of unpack
  * 2.1: Additional version adjustments of newly added plugins.
  * indentguide: use indent size from doc instead of config
  * Appropriately merged config hashes.
  * Bumping versions.
  * Update language_v.lua
  * Update language_rivet.lua
  * Rename `indentguide` variables
  * Allow customizing `indentguide` highlight color
  * Add multicursor support to `indentguide`
  * Make `indentguide` highlight the current block
* Mon May  2 2022 scott.bradnick@suse.com
- Update to version git20220501.7bee960:
  * Update language_rivet.lua
  * `selectionhighlight`: Don't draw box around the selection
  * `selectionhighlight`: Draw frame after drawing line body
  * A plugin for generating dummy lorem ipsum text
* Wed Apr 27 2022 scott.bradnick@suse.com
- Update to version git20220425.e1f7c35:
  * Reorganize README.md
  * Update README.md
  * docs: add my plugins
  * Update README.md
  * Add how to request plugins
  * Reorganize README.md
  * Add plugin install instructions
  * fix
  * Add files via upload
  * Delete language_glaz.lua
  * Update README.md
  * Update README.md
  * Modified README
* Fri Apr 22 2022 Scott Bradnick <scott.bradnick@suse.com>
- Adding nonicons config options for:
  * .vim
  * .j2
  * .ini
  * .bash
  * .fish
* Thu Apr 21 2022 scott.bradnick@suse.com
- Update to version git20220419.2fc43f7:
  * Align `language_cpp` plugin with the one from lite-xl/lite-xl
* Thu Apr 14 2022 Scott Bradnick <scott.bradnick@suse.com>
- Seems to use 'gitdiff_highlight' not 'gitdiff-highlight'.
* Thu Apr 14 2022 Scott Bradnick <scott.bradnick@suse.com>
- Adding .patch files for datetimestamps & nonicons
- Adding 'gitdiff-highligh' setup.
* Wed Apr 13 2022 Scott Bradnick <scott.bradnick@suse.com>
- Swapping out USERDIR for DATADIR so nonicons works by default.
  * Otherwise, each user would need to do something like:
    ln -s /usr/share/lite-xl/fonts/nonicons.ttf ~/.config/lite-xl/fonts/
* Wed Apr 13 2022 Scott Bradnick <scott.bradnick@suse.com>
- Fixing up 'console','indentguide','nonicons' plugins.
- Adding 'words' Recommends.
* Wed Apr 13 2022 Scott Bradnick <scott.bradnick@suse.com>
- Adding license and readme files to package.
* Tue Apr 12 2022 scott.bradnick@suse.com
- Update to version git20220404.81289cb:
  * Reorganize README.md
  * [language_glaz] add keyword \`vec\`
  * Added lsp and widget to README
  * add treeview-menu-extender plugin (#36)
  * typingspeed: added typingspeed plugin (#47)
  * Reorganize README.md
  * update `language_glaz`
  * Improve `smoothcaret` plugin (#46)
  * minimap: don't show on non DocView's
  * fix pattern for `glaz.proj` files
* Tue Apr 12 2022 Scott Bradnick <scott.bradnick@suse.com>
- Initial version from upstream.
